namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.Components.Auth;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Economy;
    using Eco.Gameplay.Housing;
    using Eco.Gameplay.Interactions;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Minimap;
    using Eco.Gameplay.Objects;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Property;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Gameplay.Pipes.LiquidComponents;
    using Eco.Gameplay.Pipes.Gases;
    using Eco.Gameplay.Systems.Tooltip;
    using Eco.Shared;
    using Eco.Shared.Math;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;
    using Eco.Shared.Utils;
    using Eco.Shared.View;
    using Eco.Shared.Items;
    using Eco.Gameplay.Pipes;
    using Eco.World.Blocks;
    
    [Serialized]    
    [RequireComponent(typeof(PropertyAuthComponent))]
    [RequireComponent(typeof(MinimapComponent))]                
    [RequireComponent(typeof(LinkComponent))]                   
    [RequireComponent(typeof(PublicStorageComponent))]                
               
    public partial class KitchencabinetsingularObject : 
        WorldObject    
    {
        public override string FriendlyName { get { return "Basic Kitchen Cupboard"; } } 


        protected override void Initialize()
        {
            this.GetComponent<MinimapComponent>().Initialize("Storage");                                 

            var storage = this.GetComponent<PublicStorageComponent>();
            storage.Initialize(16);
            storage.Storage.AddRestriction(new NotCarriedRestriction()); // can't store block or large items


        }

        public override void Destroy()
        {
            base.Destroy();
        }
       
    }

    [Serialized]
    public partial class KitchencabinetsingularItem : WorldObjectItem<KitchencabinetsingularObject>
    {
        public override string FriendlyName { get { return "Basic Kitchen Cupboard"; } } 
        public override string Description  { get { return  "Although not amazing to look at its sure handy for storing things!"; } }

        static KitchencabinetsingularItem()
        {
            
        }

    }


    [RequiresSkill(typeof(LumberWoodworkingSkill), 2)]
    public partial class KitchencabinetsingularRecipe : Recipe
    {
        public KitchencabinetsingularRecipe()
        {
            this.Products = new CraftingElement[]
            {
                new CraftingElement<KitchencabinetsingularItem>(),
            };

            this.Ingredients = new CraftingElement[]
            {
                new CraftingElement<LumberItem>(typeof(LumberWoodworkingEfficiencySkill), 40, LumberWoodworkingEfficiencySkill.MultiplicativeStrategy),
                   
            };
            SkillModifiedValue value = new SkillModifiedValue(1, LumberWoodworkingSpeedSkill.MultiplicativeStrategy, typeof(LumberWoodworkingSpeedSkill), Localizer.Do("craft time"));
            SkillModifiedValueManager.AddBenefitForObject(typeof(KitchencabinetsingularRecipe), Item.Get<KitchencabinetsingularItem>().UILink(), value);
            SkillModifiedValueManager.AddSkillBenefit(Item.Get<KitchencabinetsingularItem>().UILink(), value);
            this.CraftMinutes = value;
            this.Initialize("Kitchencabinetsingular", typeof(KitchencabinetsingularRecipe));
            CraftingComponent.AddRecipe(typeof(CarpentryTableObject), this);
        }
    }
}